2003.05.12
- many gui fixes, new table sorters (sorted insertion)
- redesign of source code started

2002.11.10
- Added upload by request (file still can be uploaded, but you need the *force*)

2002.11.01
- Changed the board update algorithm. It should now update all boards, not only the most active ones.
- SearchTextField is disabled if request is processed
- Add search results to downloadTable with doubleclick

2002.10.26
- Searchicon diabled if search is running

2002.10.25
- Start corresponding uplication if file is doubleclicked in up/downloadtable
- Fixed nullPointerException in FileAccess.getAllEntries

2002.10.23
- Added workaround for unfinished downloads bug
- If no attachment is selected, all attachments get into the download table

2002.10.22
- Changed Attachment display

2002.06.26
- Max. board name that gets displayed in the boardInfoFrame is 64 characters long.

2002.06.20
- Help frame now can display several documents (choose one with the combo box)
- Help frame now scrolls to the top of the text when displaying a document.
- Failed message uploads are retried on next startup
- Small bugfixes in MessageUploadThread

2002.06.16
- Added file type selector to search tab
- Added help frame, hope I can collect some hints for that

2002.06.10
- Continued development of Frost. Started with some smaller bugfixes.
- Buttons get updated if board config gets changed
- Improved Board update. More used boards get updated more often.
- BoardInfoFrame now displays more known boards

2001.12.17
- Upload table is checked on startup, non existent files are no longer added to upload table

2001.12.16
- Fixed PGP signature failure
- Fixed several NumberFormatExceptions

2001.12.15
- Message updated button always enabled
- Fixed 'missing boards' bug
- Added notStings to the search textfield.

2001.12.11
- Added metadata support (splitfiles are now compatible to fproxy)

2001.12.08
- update of all available boards

2001.12.07
- Using jar file now

2001.12.03
- Fixed bug in insertThread

2001.12.02
- Fixed severy bug causing Frost to use 100% CPU on FormatError

2001.12.01
- Imroved key update mechanism.
- fixed bug causing restarts of unfinished uploads

2001.11.29
- Added *age filter to search requests
- Selected messages are printed to terminal
- Added tof popup with Save Message entry.
- Added secure updates board

2001.11.28
- Secure messages sorted right now
- Fixed board selection bug shitfuck
- Fixed damned shitfuck bug with uploading large files
- Where have I learned these words?

2001.11.27
- Reset lastSuccess in UpdateIdThread.java after midnight GMT

2001.11.24
- Fixed bug causing too many tofDownload threads on secure boards
- Boards are sorted alphabetically now
- Added warning message if message got no subject

2001.11.23
- Added secure boards
- Fixed severe security bug

2001.11.16
- Added retry/cancel window if message upload fails
- Removed Array out of bounds exception in tofDownload.java

2001.11.15
- Keep actual index files

2001.11.14
- Keep downloaded chunks until file is downloaded or removed from download table

2001.11.13
- fixed bug that prevented the key exchange system to run after 0:00 GMT (without restarting)

2001.11.12
- no redirect on messages

2001.11.11
- released

.
. (damned, was too lazy to write everything down)
.

2001.11.04
- Attachments are uploaded with "upload htl" and not "tof upload htl"
- ID files are updated correct now
- Upload Threads are started max. every 10 seconds (less IOExceptions and connection failures)
- Added sorting for "sharedTable"
- sorting by alphabet is no more case sensitive
- sorting by htl works now
- splitfile upload returns "Error" if one chunk failed.
- removed NullPointerException from UploadIdThread.java
- removed NullpointerException from tofUpload.java
- reduced Memory usage for uploads Threads to some few bytes
- "Requested" files are no longer reset to "Never" after restarting Frost

2001.11.03
- Added 60 seconds Thread.sleep to tofDownload and tofDownloadBack

2001.11.01
- Fixed Timestamp bug
- TOF Messages are now sorted my index if date (day) is equal

2001.10.30
- Added CofE's random splitfile download idea
- Fixed a bug in SearchThread (did not display frame1.chk map's keys)

2001.10.28
- Back on main CVS branch
- Lowered default upload htl's (all of them) to 5
- Removed bug in SearchThread (display of chk.txt's keys was wrong)
- Added "Upload selected files" popup entry to upload popup
- Improved several things in UploadIdThread.java

2001.10.27
- Removed reply bug
- Removed multiple message bug
- Added search for "*" (are you happy now spaetz?)
- damned, I forgot the rest...

2001.10.26
- Added search for multiple words
- Successful downloads are now added to chk database
- Boards are no longer case sensitive (Case is shown, but internally all boards are handled lower case)
- fixed NullPointerException with empty board selector
- fixed second NullPointerException with empty board selector
- Only exchange keyfiles if all upload/download threads have finished
- Limited max search results to 5000
- Removed naming bug in file exchange
- fixed bug in SearchThread
- Added chk.txt search results
- Equal search results only show up once in the search results
-----------------------------------------------------------------------------------------

08.09.2001
- Remember lastUsedDirectory in OptionsFrame
- removed bug: remove done uploads works now.

31.08.2001
- Added SPlitPane to Search Tab

30.08.2001
- downloadAttachmentsButton disabled if no attachments in message
- Default Icons in data directory are now used if no skin is selected
- Remeber last used directory in "Add Attachments Dialog"

29.08.2001
- Fixed null pointer exception in files.java

28.08.2001
- Added "Important" state to uploads
- Added upload popup menu

04.08.2001
- Added "Use Skins" option to the options frame

03.08.2001
- Added attachments to TOF
- Shutdown process can now be interrupted without loss of data
- Added: Remove finished downloads after 5 minutes
- Added: Remove finished uploads after 5 minutes

31.07.2001
- Added date and time to title bar

06.07.2001
- Added several options to the OptionsFrame

04.07.2001
- Fixed "automaticUpdate" bug in OptionsFrame.java


03.07.2001
- Fixed some serious bugs in KeyExchangeThread
- Fixed bug in keys.java (addKeys(Map newKeys) did not update key info properly)
- KeyExchangeThread now uses GMT time
- Added menu entry: Download yesterdays keys

01.07.2001
- Moved options to options frame.
- improved frame1 code and reduced it's size from 118kb to 96kb!

29.06.2001
- Added Popup Menues to Search and Download Table. Popup Menues can be created and extended easy.
- Removed some (useless) code from frame1.java.

28.06.2001
- Uploads resulted in "Error" will be reset to "Waiting" on next startup.

27.06.2001
- Fixed sorting by size in search table

24.06.2001
- Fixed some bugs in requestThread.java

23.06.2001
- fixed bug in requestThread making an ArrayOutOfBounds Exception if an actually downloaded file is removed from the download table

22.06.2001
- Added shared folders
- Added "New board" action listener (press return to add board)
- Added "Shared folders" jList1 action listener (Press DELETE to remove selected fodler)
- Added Uploads/Update List menu entrie (rereads the shared folders and adds entries to the upload list)
- Uploading is now default active
- New preferences frame (will move the options tab to this frame soon)

16.06.2001
- Don't remember all changes...
- Keyfile handling completely rewritten (no more 900Kb keyfiles)
- Several new options in the keys tab
- Word wrapping for TOF messages
- Automatic download of old messages (option in TOF tab)

10.06.2001
- Checked in some changes from Driftbrain concerning Linux.

08.06.2001
- The "Markers" did not scale good enough for lots of messages. Now trying the date thing.

07.06.2001
- Using "Markers" to determine actual message index. Old Messages can be downloaded via TOF / Download old messages.
- Search for multiple words divided by spaces. For example "venom resurrection mp3" or ".zip mame"
- No more Tool menu
- TOFUP display bug fixed
- No more defaultkeys. They died on freenet because nobody needed it (Because YOU use Frost, THX)

06.06.2001
- VERY NICE small message icon if a new message arrives!!!
- Long filenames setting from downlaod tab is saved to frost.ini.
- TOF is updated automatically
- Added Warning message to renaming tool
- Automatic update setting is saved to frost.ini
- hopefully fixed bug with insertThread

05.06.2001
- Username is saved to ini file.
- KeyExchange and TofUpdate don't start at the same time (3 seconds difference).
- Empty TOF files do not show up in the TOF table
- Empty TOF files are removed and downloaded again.
- Last used board is saved to ini file and automatically updated on startup.
- Keyfiles are added immediately to the database.
- Added Time to TOF Messages
- Number of upload- and downloadThreads is managed separately.

04.06.2001
- Completely rewrote the sortfunctions for the tables. It now WORKES!
- Changed behaviour if new keys are added from freenet.
- Added a Save Search Results entry into the file menu.
- Removed two 'Delete' Buttons (Downloads / Uploads). Use the Del button on the keyboard instead.
- Many small things I don't even want to remember.

03.06.2001
- TOF table display speed improved. New sortroutine for entries.
- New files.readFile(). Now uses Stringbuffers and is really fast.
- Cleaned up code a bit
- Turned on sortfunction for tables again. Fixed some things, but am not sure if all works.

02.06.2001
- Improved tofUpload class
- Improved tof Table display
- tof messages are now sorted by index
- Added tof/key up/download htl to options tab

01.06.2001
- Long filenames in download tab. Keyinfo is stored in filename (Very useful for mp3).
- new download thread. If a filename already exists, but the files are different, files are indexed. If the files are equal, only one is kept.

31.05.2001
- Completely rewrote the tofUpload class. Should be faster now and supports upload of multiple Messages at the same time.
- TOF Table is now updated correctly (I hope so...).
- TOF Table can now be sorted (You damned little Mouselistener).
- TOF preview and Message Frame now have Line Wrapping enabled.
- Added Reply button to TOF

29.05.2001
- removed unused label from TOF page
- removed unused labels from Status line
- Added Up/Down Buttons to upload/downloadlist. Selected up/downloads are moved to the beginning/end of the list and are down/uploaded earlier/later.

28.05.2001
- TOF messages are now organized in a table
- completely rewriten Threadmanagement.
- Unknown values NEVER replace known Data in Database.

24.05.2001
- Uploads are now added to database (with stat/size blabla)
- Added "Hide bad keys" to search tab
- Search results can be sorted (change order by pressing Shift)
- Download list can be sorted
- Upload list can be sorted
- You can now delete keys in the search tab (only table view) by selecting keys and pressing "del".

23.05.2001
- Added Date to keyObject

09.05.2001
- Status of up/downloads is now reset to done/failed/waiting on startup

08.05.2001
- Fixed Bug in Upload list (Failed uploads added to download list???)
- Added Table view for search results.

07.05.2001
- Uploadtab now uses a JTable
- Quickload now uses the new requestThread class

21.04.2001
- removed updaters
- removed "make download list"
- removed "make upload list"

20.04.2001
- GUI changed. I hope it is more usable now.
- Smaller bugfixes

13.04.2001
- TOF sometimes did not find a correct empty slot. I hope that bug is gone now...
- Messages are sent, even if "automatic TOF update" is disabled.
- Added a warning message on startup if some options are not correct.
- Automatic keydownload and tof update are disabled on startup if keypool directory is not found.
- Smaller changes...

09.04.2001
- Added "Disable automatic TOF update" button

08.04.2001
- Fixed bug in tof (renaming upload files)

06.04.2001
- TOF messages are sent with no need to "start transfer".
- Keys are uploaded with no need to "start transfer".
- Increased TOF download htl to 40
- Keys are automatically downloaded on startup

05.04.2001
- Keys are sorted on startup
- Key handling uses less ram and is much faster
- Updaters added to Upload tab. Updaters are files which are uploaded every day.
	The date in yyyyMMdd format is added to the filename.
- Added TOF (Text over Frost) support.

29.03.2001
- Added icons to tree structure.
- Added "Add files to upload list" button to uploads tab
- Fixed "Make download file" bug.
- "\" is now allowed in keys but not recognized as path separator.
	Please donīt use it, use "/" instead.
- Added Uploads / Clear filelist
- Added Uploads / Clear keylist
- Added Uploads / Save uploadlist
- Added uploads / Load Uploadlist

28.03.2001
- fixed small bug in "shared folder" and removed textField
- Keyfiles are inserted at the top of the upload list, not at the bottom.
- If Frost ist started for the first time, the directories "downloads" and "keypool"
	will be created in the Frost directory, and will be used as default. You can change these
	directories in the options tab.
- Added a README.txt file
- Added a frost.bat file. You can start it from the windows explorer or make a shortcut to it.

27.03.2001
- Multiple directories can now be added at "shared folders" at once.
- Several improvements to the "shared folders". Nodes are now editable.
- fixed bug in "insertUpload"
- It should now be possible to completely design a upload structure within "shared folders".

26.03.2001
- fixed small bug in options pane.
- Added "Save Up/Downloadlist on exit" to options tab. Up/Downloadlist will be
	automatically saved on exit and reloaded on startup.
-	fixed bug(feature?) in "shared folders". You now can upload more than one directory at a time.

23.03.2001
- Options/Set insert/request executable added
- fixed "Open downloadlist"
- Automatic inserting collided uploads to keyindex (options/record uploads)


22.03.2001
- Improved Upload / Download handling (hope I did not break it...)
- Added Max Threads and Thread interval to options tab
- Automatic thread increase added. (options tab)
- Automatic inserting successful uploads to keyindex (options/record uploads)

21.03.2001
- Keyindex | Remove faulty keys now removes indentical keys too.
- Added Quickload Button to Downloads tab
- Added Upload HTL to Options tab
- Console is no more editable
- Added automatic restart of failed uploads to options menu

20.03.2001
- Save Keys as... added to File menu
- Clear Downloads added to Downloads menu
- Save Downloadlist as... added to Downloads menu
- Rename filenames/directories with spaces (replace space with _) added to Tools menu
- Selected Node is added to Shared folders textfield
- Added ActionListened to Search Textfield (Search by hitting return)
- Automatic search for empty slot if keyfile should be uploaded
- Quickload bar in the downloads tab added (enter freenet key and press return to immediately download)

15.03.2001
- Console output added
- Console | Clear Console added
- Console | Save Console as... added
- Console | Add successfull uploaded keys to keyindex added
- Slightly improved "addStringToData(String)"

14.03.2001
- Download should work now.
- Upload will be possible soon (this afternoon)
- Upload should work now
- Fixed these damned threads, Yeah Baby (Yeah).

13.03.2001
- lastUsedDirectory is now remembered
- Make download file now works
- Added Options tab
- Save keys on exit added
